"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEmojiMessage = exports.getMessage = exports.getActionEmojiCode = exports.getActionEmoji = exports.getAction = exports.getActions = void 0;
const actions = require("../data/actions.json");
const _actions = actions.reduce((all, one) => {
    all[one.type] = one;
    return all;
}, {});
function getActions() {
    return actions;
}
exports.getActions = getActions;
function getAction(type) {
    return _actions[type] || null;
}
exports.getAction = getAction;
function getActionEmoji(type) {
    const action = getAction(type);
    if (!(action === null || action === void 0 ? void 0 : action.emoji)) {
        throw new Error(`unknown emoji for type: ${type}`);
    }
    return action === null || action === void 0 ? void 0 : action.emoji;
}
exports.getActionEmoji = getActionEmoji;
function getActionEmojiCode(type) {
    const action = getAction(type);
    if (!(action === null || action === void 0 ? void 0 : action.code)) {
        throw new Error(`unknown emoji(code) for type: ${type}`);
    }
    return action === null || action === void 0 ? void 0 : action.code;
}
exports.getActionEmojiCode = getActionEmojiCode;
function getMessage(type, scope, subject) {
    if (!getAction(type)) {
        throw new Error(`unknown commit type: ${type}`);
    }
    if (!scope) {
        return `${type}: ${subject}`;
    }
    return `${type}(${scope}): ${subject}`;
}
exports.getMessage = getMessage;
function getEmojiMessage(type, scope, subject) {
    const emojiCode = getActionEmojiCode(type);
    if (!scope) {
        return `${emojiCode}: ${subject}`;
    }
    return `${emojiCode}(${scope}): ${subject}`;
}
exports.getEmojiMessage = getEmojiMessage;
